Validation rules in EJ2 JavaScript Form Validation

21 Aug 202624 minutes to read

Default Rules

The FormValidator has following default validation rules, which are used to validate the form.

Rules Description Example
required The form input element must have any input values a or 1 or -
email The form input element must have valid email format values <[email protected]>
url The form input element must have valid url format values http://syncfusion.com/
date The form input element must have valid date format values 05/15/2017
dateIso The form input element must have valid dateISO format values 2017-05-15
number The form input element must have valid number format values 1.0 or 1
digits The form input element must have valid digits values 1
maxLength Input value must have less than or equal to maxLength character length if maxLength: 5, check is valid and checking is invalid
minLength Input value must have greater than or equal to minLength character length if minLength: 5, testing is valid and test is invalid
rangeLength Input value must have value between rangeLength character length if rangeLength: [4,5], test is valid and key is invalid
range Input value must have value between range number if range: [4,5], 4 is valid and 6 is invalid
max Input value must have less than or equal to max number if max: 3, 3 is valid and 4 is invalid
min Input value must have greater than or equal to min number if min: 4, 5 is valid and 2 is invalid
regex Input value must have valid regex format if regex: '^[A-z]+$', a is valid and 1 is invalid

The rules option should map the input element’s name attribute.
The FormValidator library only validates the mapped input elements.

Defining Custom Rules

You can also define custom rules in the rules property and validate the form with custom logics.

The custom validation method need to return the boolean value for validating an input.

var customFn = (args) => {
    return args['value'].length >= 5;
};
var options = {
    rules: {
        'user': { required: true },
        'password': { minLength: [customFn, 'Need atleast 5 letters'] }
    }
};
var formObject = new ej.inputs.FormValidator('#form-element', options);
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <form id="form-element" class="form-horizontal">
            <div class="form-group">
                <label class="col-sm-3 control-label" for="user">User Name</label>
                <div class="col-sm-6">
                    <input type="text" id="required" name="user" class="form-control">
                </div>
            </div>
            <div class="form-group">
                <label class="col-sm-3 control-label" for="password">Password</label>
                <div class="col-sm-6">
                    <input type="password" id="number" name="password" class="form-control">
                </div>
            </div>
        </form>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
    visibility: hidden;
    padding: 10px;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    top: 45%;
    left: 45%;
}

Adding or Removing Rules

After creating FormValidator object, you can add more rules to an input element by using addRules
method and you can also remove an existing rule from the input element by using removeRules method.

import {FormValidator, FormValidatorModel} from '@syncfusion/ej2-inputs';

let options: FormValidatorModel = {
    rules: {
        'user': { required: true },
        'age': { number: true }
    }
}
let formObject: FormValidator = new FormValidator('#form-element', options);
// Add email rule to user element
formObject.addRules('user', { maxLength: 7 });
// Remove number rule from age element
formObject.removeRules('age', ['number']);

Validating a Form

You can manually trigger validation by calling the validate method of FormValidator.

var options = {
    rules: {
        'product_name': { required: true },
        'rating': { range: [1, 5] }
    }
};
var formObject = new ej.inputs.FormValidator('#form-element', options);
// validate all input elements in the form
formObject.validate();
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <form id="form-element" class="form-horizontal">
            <div class="form-group">
                <label class="col-sm-3 control-label" for="product_name">Product Name</label>
                <div class="col-sm-6">
                    <input type="text" id="required" name="product_name" class="form-control">
                </div>
            </div>
            <div class="form-group">
                <label class="col-sm-3 control-label" for="rating">Rating</label>
                <div class="col-sm-6">
                    <input type="text" id="number" name="rating" class="form-control">
                </div>
            </div>
        </form>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
    visibility: hidden;
    padding: 10px;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    top: 45%;
    left: 45%;
}

Validating a Single Element

The validate method have an optional argument, where you can pass an input element’s name attribute to validate its value against the defined rule.

import {FormValidator, FormValidatorModel} from '@syncfusion/ej2-inputs';

let options: FormValidatorModel = {
    rules: {
        'user': { required: true },
        'age': { number: true }
    }
}
let formObject: FormValidator = new FormValidator('#form-element', options);
// validate user element alone
formObject.validate('user');

HTML5 Form Validation

HTML5 validation is the ability to validate the user data without relying any scripts. This is done by using validation attributes on form elements, which allows you to specify rules for a form input like whether a value needs to be filled In the maximum and minimum length of the data, whether it needs to be number, an email address, or something else and pattern that it match. If the entered data follows all the
specified rules, it is considered as valid; if not, it is considered as invalid.

// Initialize the Submit Button.
    var buttonFormValidate = new ej.buttons.Button({
        isPrimary: true
    });
    buttonFormValidate.appendTo('#validateSubmit');
    // Initialize the Reset Button.
    var buttonReset = new ej.buttons.Button();
    buttonReset.appendTo('#resetbtn');
    var options = {
        // Initialize the CustomPlacement.
        customPlacement: function (inputElement, errorElement) {
            inputElement.parentElement.appendChild(errorElement);
        }
    };

    // Initialize the FormValidator.
    var formObj = new ej.inputs.FormValidator('#formId', options);
    document.getElementById('formId').addEventListener("submit", function (e) {
        e.preventDefault();
        if (formObj.validate()) {
            alert('Your form has been submitted.');
            formObj.reset();
        }
    });
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Form Validator</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/material.css" rel="stylesheet">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div class="content-wrapper" style="margin-bottom: 25px">
            <div class="form-title"><span>HTML5 Validation</span></div>
            <form id="formId" class="form-horizontal">
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="required" name="Required" data-required-message="Required field" required="" data-msg-containerid="requiredError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="required">Required</label>
                    </div>
                    <div id="requiredError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="email" name="Email" data-validation="email" data-email-message="Please enter valid email address." data-required-message="Required field" required="" data-msg-containerid="emailError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="email">Email</label>
                    </div>
                    <div id="emailError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="url" name="Url" data-validation="url" data-url-message="Please enter valid url." data-required-message="Required field" required="" data-msg-containerid="urlError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="url">URL</label>
                    </div>
                    <div id="urlError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="date" name="Date" data-validation="date" data-date-message="Please enter valid date." data-required-message="Required field" required="" data-msg-containerid="dateError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="date">Date</label>
                    </div>
                    <div id="dateError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="dateIso" name="DateISO" dateiso="true" data-dateiso-message="Please enter valid dateISO format(YYYY-MM-DD)." data-required-message="Required field" required="" data-msg-containerid="dateisoError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="dateIso">Date ISO (YYYY-MM-DD)</label>
                    </div>
                    <div id="dateisoError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="number" name="Number" data-validation="number" data-number-message="Please enter Integer or Decimal only." data-required-message="Required field" required="" data-msg-containerid="numberError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="number">Integer or Decimal</label>
                    </div>
                    <div id="numberError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="digits" name="Digits" digits="true" data-digits-message="Please enter digits only." data-required-message="Required field" required="" data-msg-containerid="digitError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="digits">Positive Integer</label>
                    </div>
                    <div id="digitError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="maxlen" name="MaxLength" maxlength="5" data-maxlength-message="Please enter no more than 5 characters." data-required-message="Required field" required="" data-msg-containerid="maxlenError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="maxlen">Maximum 5 characters</label>
                    </div>
                    <div id="maxlenError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="minlen" name="MinLength" minlength="5" data-minlength-message="Please enter at least 5 characters." data-required-message="Required field" required="" data-msg-containerid="minlenError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="minlen">Minimum 5 characters</label>
                    </div>
                    <div id="minlenError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="rangelen" name="RangeLength" rangelength="[5, 10]" data-rangelength-message="Please enter a value between 5 and 10 characters long." data-required-message="Required field" required="" data-msg-containerid="ranlenError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="rangelen">Characters length between 5 to 10</label>
                    </div>
                    <div id="ranlenError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="range" name="Range" range="[5, 10]" data-range-message="Please enter a value between 5 and 10." data-required-message="Required field" required="" data-msg-containerid="ranError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="range">Value between 5 to 10</label>
                    </div>
                    <div id="ranError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="max" name="Max" max="5" data-max-message="Please enter a value less than or equal to 5." data-required-message="Required field" required="" data-msg-containerid="maxError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="max">Max (maximum value 5)</label>
                    </div>
                    <div id="maxError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="min" name="Min" min="5" data-min-message="Please enter a value greater than or equal to 5." data-required-message="Required field" required="" data-msg-containerid="minError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="min">Min (minimum value 5)</label>
                    </div>
                    <div id="minError"></div>
                </div>
                <div class="form-group">
                    <div class="e-float-input">
                        <input type="text" id="regex" name="Regex" regex="^[a-zA-Z]+$" data-regex-message="accepts alphabets only" data-required-message="Required field" required="" data-msg-containerid="regexError">
                        <span class="e-float-line"></span>
                        <label class="e-float-text" for="regex">Regex (accepts alphabets only)</label>
                    </div>
                    <div id="regexError"></div>
                </div>
                <div class="row">
                    <div style="float: left;margin: 0 10% 0 30%">
                        <button id="validateSubmit" class="samplebtn" type="submit" style="height: 35px;">Submit</button>
                    </div>
                    <div>
                        <button id="resetbtn" class="samplebtn" type="reset" style="height: 35px;">Reset</button>
                    </div>
                </div>
            </form>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
#container {
    visibility: hidden;
    padding: 10px;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    top: 45%;
    left: 45%;
}

.e-error,
.e-float-text {
    font-weight: 500;
}

table,
td,
th {
    padding: 5px;
}

.form-horizontal .form-group {
    margin-left: 0px;
    margin-right: 0px;
}

form {
    border: 1px solid #ccc;
    box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.36);
    border-radius: 5px;
    background: #f9f9f9;
    padding: 23px;
    padding-bottom: 20px;
}

.form-title {
    width: 100%;
    text-align: center;
    padding: 10px;
    font-size: 16px;
    font-weight: 500;
    color: rgba(0, 0, 0, 0.70);
}

Validation Rules in React Form Validation Library

9 Aug 202624 minutes to read

Default Rules

The FormValidator provides the following default validation rules for form validation:

Rules Description Example
required The form input element must have any input values a or 1 or -
email The form input element must have valid email format values [email protected]
url The form input element must have valid url format values http://syncfusion.com/
date The form input element must have valid date format values 05/15/2017
dateIso The form input element must have valid dateISO format values 2017-05-15
number The form input element must have valid number format values 1.0 or 1
digits The form input element must have valid digits values 1
maxLength Input value must have less than or equal to maxLength character length if maxLength: 5, check is valid and checking is invalid
minLength Input value must have greater than or equal to minLength character length if minLength: 5, testing is valid and test is invalid
rangeLength Input value must have value between rangeLength character length if rangeLength: [4,5], test is valid and key is invalid
range Input value must have value between range number if range: [4,5], 4 is valid and 6 is invalid
max Input value must have less than or equal to max number if max: 3, 3 is valid and 4 is invalid
min Input value must have greater than or equal to min number if min: 4, 5 is valid and 2 is invalid
regex Input value must have valid regex format if regex: '^[A-z]+$', a is valid and 1 is invalid

The rules option must map the input element’s name attribute.
The FormValidator validates only the mapped input elements.

Defining Custom Rules

You can define custom rules in the rules property to validate the form with custom logic.

The custom validation method must return a boolean value to indicate validation success or failure.

import { FormValidator } from '@syncfusion/ej2-inputs';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
export default class Validation extends React.Component {
    dialogInstance;
    formObject;
    animationSettings = { effect: 'Zoom' };
    floatFocus(args) {
        args.target.parentElement.classList.add('e-input-focus');
    }
    floatBlur(args) {
        args.target.parentElement.classList.remove('e-input-focus');
    }
    // Dialog will be closed, while clicking on overlay
    onOverlayClick() {
        this.dialogInstance.hide();
    }
    componentDidMount() {
        const options = {
            // add the rules for validation
            rules: {
                'email': {
                    required: [true, '* Enter your email']
                },
                'mobile': {
                    required: [true, '* Enter your mobile number']
                },
                'name': {
                    required: [true, '* Enter your name']
                },
            }
        };
        // initialize the form validator
        this.formObject = new FormValidator('#form1', options);
    }
    onSubmitClick() {
        if (this.formObject.validate()) {
            this.formObject.element.reset();
            this.dialogInstance.show();
        }
    }
    render() {
        return (<div className='control-pane'>
    <div className='control-section col-lg-12'>
      <h4 className="form-title">Validation Support</h4>
      <div className='validation_wrapper'>
        <div className="control_wrapper" id="control_wrapper">
          <form id="form1" method="post">
            <div className="form-group">
              <div className="e-float-input">
                <input type="text" id="name" name="name" onFocus={this.floatFocus} onBlur={this.floatBlur} data-msg-containerid="nameError"/>
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top" htmlFor="name">Name</label>
              </div>
              <div id="nameError"/>
            </div>
            <div className="form-group">
              <div className="e-float-input">
                <input type="email" id="Email" name="email" data-msg-containerid="mailError"/>
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top" htmlFor="email">Email</label>
              </div>
              <div id="mailError"/>
            </div>
            <div className="form-group">
              <div className="e-float-input">
                <input type="text" id="mobileno" name="mobile" data-msg-containerid="noError"/>
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top" htmlFor="mobile">Mobile no</label>
              </div>
              <div id="noError"/>
            </div>
          </form>
          <br />
          <br />
          <div className="submitBtn">
            <button className="submit-btn e-btn" onClick={this.onSubmitClick = this.onSubmitClick.bind(this)} id="submit-btn">Submit</button>
          </div>
          <div id="confirmationDialog"/> </div>
        </div>
      </div>
      <DialogComponent id="defaultdialog" isModal={true} visible={false} content='Your details has been updated successfully, Thank you' animationSettings={this.animationSettings} width={'50%'} ref={dialog => this.dialogInstance = dialog} target={'.control-section'} overlayClick={this.onOverlayClick = this.onOverlayClick.bind(this)}/>
    </div>);
    }
}
ReactDOM.render(<Validation />, document.getElementById('validation'));
import { select } from '@syncfusion/ej2-base';
import { FormValidator, FormValidatorModel } from '@syncfusion/ej2-inputs';
import { DialogComponent } from '@syncfusion/ej2-react-popups';
import * as React from 'react';
import * as ReactDOM from 'react-dom';

export default class Validation extends React.Component<{}, {}> {
public dialogInstance: DialogComponent;
public formObject: FormValidator;
private animationSettings: object = { effect: 'Zoom' };
public floatFocus(args: any): void {
  args.target.parentElement.classList.add('e-input-focus');
}
public floatBlur(args: any): void {
  args.target.parentElement.classList.remove('e-input-focus');
}
  // Dialog will be closed, while clicking on overlay
  public onOverlayClick() {
        this.dialogInstance.hide();
  }
  public componentDidMount(): void {
        const options: FormValidatorModel = {
          // add the rules for validation
         rules: {
          'email': {
            required: [true, '* Enter your email']
          },
          'mobile': {
            required: [true, '* Enter your mobile number']
          },
          'name': {
              required: [true, '* Enter your name']
          },
        }
      };
      // initialize the form validator
      this.formObject = new FormValidator('#form1', options);
  }

  public onSubmitClick(): void {
  if(this.formObject.validate()) {
    this.formObject.element.reset();
    this.dialogInstance.show();
      }
  }

public render(): JSX.Element {
  return (    <div className = 'control-pane'>
    <div className='control-section col-lg-12'>
      <h4 className="form-title">Validation Support</h4>
      <div className='validation_wrapper'>
        <div className="control_wrapper" id="control_wrapper">
          <form id="form1"  method="post">
            <div className="form-group" >
              <div className="e-float-input">
                <input type="text" id="name" name="name" onFocus= {this.floatFocus} onBlur= {this.floatBlur}  data-msg-containerid="nameError" />
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top" htmlFor="name">Name</label>
              </div>
              <div id="nameError"/>
            </div>
            <div className="form-group">
              <div className="e-float-input">
                <input type="email" id="Email" name="email" data-msg-containerid="mailError"/>
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top" htmlFor="email" >Email</label>
              </div>
              <div id="mailError"/>
            </div>
            <div className="form-group" >
              <div className="e-float-input">
                <input type="text" id="mobileno" name="mobile" data-msg-containerid="noError" />
                <span className="e-float-line"/>
                <label className="e-float-text e-label-top"  htmlFor="mobile" >Mobile no</label>
              </div>
              <div id="noError"/>
            </div>
          </form>
          <br/>
          <br/>
          <div className="submitBtn">
            <button className="submit-btn e-btn" onClick={this.onSubmitClick = this.onSubmitClick.bind(this)} id="submit-btn">Submit</button>
          </div>
          <div id="confirmationDialog"/> </div>
        </div>
      </div>
      <DialogComponent id="defaultdialog" isModal={true} visible ={false} content = 'Your details has been updated successfully, Thank you' animationSettings={this.animationSettings} width={'50%'}  ref={dialog => this.dialogInstance = dialog!}
      target={'.control-section'} overlayClick={this.onOverlayClick=this.onOverlayClick.bind(this)} />
    </div>) }
}

ReactDOM.render(<Validation />, document.getElementById('validation'));

Adding or Removing Rules

After creating a FormValidator instance, you can add rules to an input element using the addRules method, or remove existing rules using the removeRules method.

import { FormValidator, FormValidatorModel } from '@syncfusion/ej2-inputs';
import * as React from 'react';

export default class Validation extends React.Component<{}, {}> {
public formObject: FormValidator;

public componentDidMount(): void {
        const options: FormValidatorModel = {
         rules: {
          'email': {
            required: [true, '* Enter your email']
          },
          'mobile': {
            required: [true, '* Enter your mobile number']
          },
          'name': {
              required: [true, '* Enter your name']
          },
        }
      };
      this.formObject = new FormValidator('#form1', options);
      // Add email rule to user element
      this.formObject.addRules('name', { maxLength : [5, 'Character count should not greater than 5'] });
      // Remove number rule from age element
      this.formObject.removeRules('mobile', ['number']);
  }

  public render() {
    return (
      <form id='form1'>
        <div>
          <input type='text' className='e-input' name='email'/>
        </div>
        <div>
          <input type='text' className='e-input' name='name'/>
        </div>
        <div>
          <input type='text' className='e-input' name='mobile'/>
        </div>
      </form>
    )
  }
}

Validating a single Element

The validate method accepts an optional argument where you can pass an input element’s name attribute to validate its value against the defined rules.

import { FormValidator, FormValidatorModel } from '@syncfusion/ej2-inputs';
import * as React from 'react';

export default class Validation extends React.Component<{}, {}> {
public formObject: FormValidator;

public componentDidMount(): void {
        const options: FormValidatorModel = {
         rules: {
          'email': {
            required: [true, '* Enter your email']
          },
          'mobile': {
            required: [true, '* Enter your mobile number']
          },
          'name': {
              required: [true, '* Enter your name']
          },
        }
      };
      this.formObject = new FormValidator('#form1', options);
      // Add email rule to user element
      this.formObject.validate('name');
  }

  public render() {
    return (
      <form id='form1'>
        <div>
          <input type='text' className='e-input' name='email'/>
        </div>
        <div>
          <input type='text' className='e-input' name='name'/>
        </div>
        <div>
          <input type='text' className='e-input' name='mobile'/>
        </div>
      </form>
    )
  }

}

Validation Rules in Vue Form Validation

21 Aug 202624 minutes to read

Default Rules

The FormValidator has following default validation rules, which are used to validate the form.

Rules Description Example
required The form input element must have any input values a or 1 or -
email The form input element must have valid email format values [email protected]
url The form input element must have valid url format values http://syncfusion.com/
date The form input element must have valid date format values 05/15/2017
dateIso The form input element must have valid dateISO format values 2017-05-15
number The form input element must have valid number format values 1.0 or 1
digit The form input element must have valid digit values 1
maxLength Input value must have less than or equal to maxLength character length if maxLength: 5, check is valid and checking is invalid
minLength Input value must have greater than or equal to minLength character length if minLength: 5, testing is valid and test is invalid
rangeLength Input value must have value between rangeLength character length if rangeLength: [4,5], test is valid and key is invalid
range Input value must have value between range number if range: [4,5], 4 is valid and 6 is invalid
max Input value must have less than or equal to max number if max: 3, 3 is valid and 4 is invalid
min Input value must have greater than or equal to min number if min: 4, 5 is valid and 2 is invalid
regex Input value must have valid regex format if regex: '^[A-z]+$', a is valid and 1 is invalid

The rules option should map the input element’s name attribute.
The FormValidator library only validates the mapped input elements.

Defining Custom Rules

You can also define custom rules in the rules property and validate the form with custom logics.

The custom validation method need to return the boolean value for validating an input.

<template>
    <div>
        <div class="col-lg-12 control-section form-support">
            <div class="control_wrapper" id="control_wrapper">
                <!-- Initialize Uploader -->
                <form id="form1" action="saveFiles.ashx" method="post">
                    <h4 class="form-title">Form Validator</h4>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="text" id="name" name="Name" data-required-message="* Enter your name" required=""
                                data-msg-containerid="nameError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="name">Name</label>
                        </div>
                        <div id="nameError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="email" id="email" name="Email" data-validation="email"
                                data-required-message="* Enter your email" required="" data-msg-containerid="mailError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="email">Email</label>
                        </div>
                        <div id="mailError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="number" id="mobileno" name="MobileNo"
                                data-required-message="* Enter your mobile number" required=""
                                data-msg-containerid="noError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="mobileno">Mobile No</label>
                        </div>
                        <div id="noError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input upload-area">
                            <input type="text" id="upload" name="upload" readonly=""
                                data-required-message="* Choose any file" required="" data-msg-containerid="uploadError">
                            <ejs-uploader id='fileupload' name="UploadFiles" :autoUpload="isAuto" :selected="onFileSelect"
                                allowedExtensions="image/*" :dropArea="dropElement" :multiple='false'></ejs-uploader>
                            <button id="browse" class="e-control e-btn e-info">Browse...</button>
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="upload">Choose a file</label>
                        </div>
                        <div id="uploadError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <textarea class="address-field" rows="4" id="Address" name="Address"></textarea>
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="address">Address</label>
                        </div>
                    </div>
                </form>
                <div class="submitBtn">
                    <button class="submit-btn e-btn" id="submit-btn">Submit</button>
                </div>
                <ejs-dialog id='uploadAlert' :header='header' showCloseIcon=true :width='width' :content='dlgContent'
                    :target='dlgTarget' :isModal='Modal' :visible="false" :animationSettings='animation' ref="dialogObj">
                </ejs-dialog>
            </div>
        </div>
    </div>
</template>

<script setup>

import { UploaderComponent as EjsUploader } from '@syncfusion/ej2-vue-inputs';
import { FormValidator } from '@syncfusion/ej2-vue-inputs';
import { DialogComponent as EjsDialog } from '@syncfusion/ej2-vue-popups';
import { onMounted, ref } from 'vue';

const dialogObj = ref(null);
const dropElement = '.control-fluid';
const isAuto = false;
var formObj = '';
const header = 'Success';
const animation = { effect: 'zoom' };
const Modal = true;
const dlgTarget = '.control_wrapper';
const dlgContent = 'Your details have been updated successfully, Thank you.';
const width = '335px';
var options = {
    //Initialize the CustomPlacement.
    customPlacement: function (inputElement, errorElement) {
        inputElement = inputElement.closest('.form-group').querySelector('.error');
        inputElement.parentElement.appendChild(errorElement);
    },
    rules: {
        'Name': {
            required: true
        },
        'Email': {
            required: true
        },
        'upload': {
            required: true
        }
    }
};

onMounted(() => {

    document.getElementById('browse').onclick = () => {
        document.getElementsByClassName('e-file-select-wrap')[0].querySelector('button').click();
        return false;
    };

    document.getElementById('submit-btn').onclick = function () {
        onFormSubmit();
    };
    formObj = new FormValidator('#form1', options);
});

const onFormSubmit = () => {
    let formStatus = formObj.validate();
    if (formStatus) {
        formObj.element.reset();
        dialogObj.value.show();
    }
};
const onFileSelect = (args) => {
    let inputElement = document.getElementById('upload');
    inputElement.value = args.filesData[0].name;
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

#container {
    visibility: hidden;
    padding-left: 5%;
    width: 100%;
}

#loader {
    color: #008cff;
    font-family: 'Helvetica Neue', 'calibiri';
    font-size: 14px;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.form-support .control_wrapper {
    max-width: 400px;
    margin: auto;
}

.form-support .address-field {
    max-height: 50px;
    resize: none;
}

.form-support #control_wrapper {
    max-width: 500px;
    margin: auto;
    border: 0.5px solid #BEBEBE;
    box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.36);
    padding: 1% 4% 2%;
    background: #f9f9f9;
}

.form-support .e-error {
    padding-top: 3px;
}

.form-support .e-upload {
    width: 100%;
    position: relative;
    margin-top: 15px;
}

.form-support .control_wrapper .e-upload .e-upload-drag-hover {
    margin: 0;
}

.form-support .submit-btn {
    margin-top: 15px;
}

.form-support .submitBtn .desc {
    margin: 2% 20% 0% 18%;
}

@media only screen and (max-width: 500px) {
    .form-support .submitBtn .desc {
        margin: 12px;
    }

    .form-support .upload-area,
    .e-bigger .upload-area {
        width: 60%;
    }
}

.form-support .submitBtn {
    position: relative;
    text-align: center;
}

.form-support .success .successmsg {
    border: 0.5px solid green;
    padding: 10%;
    color: green;
}

.form-support form#form1 {
    position: relative;
    top: 14%;
}

.form-support .e-upload {
    display: none;
}

.form-support input.choose-file {
    width: 60%;
}

.form-support button#browse {
    float: right;
    margin-right: -115px;
    margin-top: -29px;
    position: relative;
}

.fabric .form-support #browse,
.highcontrast .form-support #browse {
    top: -3px;
}

.bootstrap .form-support #browse {
    top: -6px;
}

.form-support .form-title {
    text-align: center;
}

#form1 .e-float-input:not(.e-input-group),
#form1 .e-float-input.e-control-wrapper:not(.e-input-group) {
    display: inherit;
}

input#mobileno::-webkit-inner-spin-button,
input#mobileno::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

.e-float-input.upload-area {
    width: 70%;
}
</style>
<template>
    <div>
        <div class="col-lg-12 control-section form-support">
            <div class="control_wrapper" id="control_wrapper">
                <!-- Initialize Uploader -->
                <form id="form1" action="saveFiles.ashx" method="post">
                    <h4 class="form-title">Form Validator</h4>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="text" id="name" name="Name" data-required-message="* Enter your name" required=""
                                data-msg-containerid="nameError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="name">Name</label>
                        </div>
                        <div id="nameError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="email" id="email" name="Email" data-validation="email"
                                data-required-message="* Enter your email" required="" data-msg-containerid="mailError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="email">Email</label>
                        </div>
                        <div id="mailError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <input type="number" id="mobileno" name="MobileNo"
                                data-required-message="* Enter your mobile number" required=""
                                data-msg-containerid="noError">
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="mobileno">Mobile No</label>
                        </div>
                        <div id="noError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input upload-area">
                            <input type="text" id="upload" name="upload" readonly=""
                                data-required-message="* Choose any file" required="" data-msg-containerid="uploadError">
                            <ejs-uploader id='fileupload' name="UploadFiles" :autoUpload="isAuto" :selected="onFileSelect"
                                allowedExtensions="image/*" :dropArea="dropElement" :multiple='false'></ejs-uploader>
                            <button id="browse" class="e-control e-btn e-info">Browse...</button>
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="upload">Choose a file</label>
                        </div>
                        <div id="uploadError"></div>
                    </div>
                    <div class="form-group" style="padding-top: 11px;">
                        <div class="e-float-input">
                            <textarea class="address-field" rows="4" id="Address" name="Address"></textarea>
                            <span class="e-float-line"></span>
                            <label class="e-float-text e-label-top" for="address">Address</label>
                        </div>
                    </div>
                </form>
                <div class="submitBtn">
                    <button class="submit-btn e-btn" id="submit-btn">Submit</button>
                </div>
                <ejs-dialog id='uploadAlert' :header='header' showCloseIcon=true :width='width' :content='dlgContent'
                    :target='dlgTarget' :isModal='Modal' :visible="false" :animationSettings='animation' ref="dialogObj">
                </ejs-dialog>
            </div>
        </div>
    </div>
</template>

<script>

import { UploaderComponent } from '@syncfusion/ej2-vue-inputs';
import { FormValidator } from '@syncfusion/ej2-vue-inputs';
import { DialogComponent } from '@syncfusion/ej2-vue-popups';

export default {
    name: "App",
    components: {
        "ejs-uploader": UploaderComponent,
        "ejs-dialog": DialogComponent
    },
    data: function () {
        return {
            path: {
                saveUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Save',
                removeUrl: 'https://ej2.syncfusion.com/services/api/uploadbox/Remove'
            },
            dropElement: '.control-fluid',
            extensions: '.jpg, .png',
            isAuto: false,
            formObj: '',
            header: 'Success',
            animation: { effect: 'zoom' },
            Modal: true,
            dlgTarget: '.control_wrapper',
            dlgContent: 'Your details have been updated successfully, Thank you.',
            width: '335px',
            options: {
                //Initialize the CustomPlacement.
                customPlacement: function (inputElement, errorElement) {
                    inputElement = inputElement.closest('.form-group').querySelector('.error');
                    inputElement.parentElement.appendChild(errorElement);
                },
                rules: {
                    'Name': {
                        required: true
                    },
                    'Email': {
                        required: true
                    },
                    'upload': {
                        required: true
                    }
                }
            }
        }
    },
    mounted: function () {
        document.getElementById('browse').onclick = () => {
            document.getElementsByClassName('e-file-select-wrap')[0].querySelector('button').click();
            return false;
        };
        let localObj = this;
        document.getElementById('submit-btn').onclick = function () {
            localObj.onFormSubmit();
        };
        this.formObj = new FormValidator('#form1', this.options);
    },
    methods: {
        onFormSubmit: function () {
            let formStatus = this.formObj.validate();
            if (formStatus) {
                this.formObj.element.reset();
                this.$refs.dialogObj.show();
            }
        },
        onFileSelect: function (args) {
            let inputElement = document.getElementById('upload');
            inputElement.value = args.filesData[0].name;
        },
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-inputs/styles/material.css";

#container {
    visibility: hidden;
    padding-left: 5%;
    width: 100%;
}

#loader {
    color: #008cff;
    font-family: 'Helvetica Neue', 'calibiri';
    font-size: 14px;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.form-support .control_wrapper {
    max-width: 400px;
    margin: auto;
}

.form-support .address-field {
    max-height: 50px;
    resize: none;
}

.form-support #control_wrapper {
    max-width: 500px;
    margin: auto;
    border: 0.5px solid #BEBEBE;
    box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.36);
    padding: 1% 4% 2%;
    background: #f9f9f9;
}

.form-support .e-error {
    padding-top: 3px;
}

.form-support .e-upload {
    width: 100%;
    position: relative;
    margin-top: 15px;
}

.form-support .control_wrapper .e-upload .e-upload-drag-hover {
    margin: 0;
}

.form-support .submit-btn {
    margin-top: 15px;
}

.form-support .submitBtn .desc {
    margin: 2% 20% 0% 18%;
}

@media only screen and (max-width: 500px) {
    .form-support .submitBtn .desc {
        margin: 12px;
    }

    .form-support .upload-area,
    .e-bigger .upload-area {
        width: 60%;
    }
}

.form-support .submitBtn {
    position: relative;
    text-align: center;
}

.form-support .success .successmsg {
    border: 0.5px solid green;
    padding: 10%;
    color: green;
}

.form-support form#form1 {
    position: relative;
    top: 14%;
}

.form-support .e-upload {
    display: none;
}

.form-support input.choose-file {
    width: 60%;
}

.form-support button#browse {
    float: right;
    margin-right: -115px;
    margin-top: -29px;
    position: relative;
}

.fabric .form-support #browse,
.highcontrast .form-support #browse {
    top: -3px;
}

.bootstrap .form-support #browse {
    top: -6px;
}

.form-support .form-title {
    text-align: center;
}

#form1 .e-float-input:not(.e-input-group),
#form1 .e-float-input.e-control-wrapper:not(.e-input-group) {
    display: inherit;
}

input#mobileno::-webkit-inner-spin-button,
input#mobileno::-webkit-outer-spin-button {
    -webkit-appearance: none;
    margin: 0;
}

.e-float-input.upload-area {
    width: 70%;
}</style>

Adding or Removing Rules

After creating FormValidator object, you can add more rules to an input element by using addRules method and you can also remove an existing rule from the input element by using removeRules method.

import {FormValidator, FormValidatorModel} from '@syncfusion/ej2-vue-inputs';

export default {
    data: function() {
        return {
          options : {
        //Initialize the CustomPlacement.
            customPlacement: function(inputElement, errorElement) {
                inputElement = inputElement.closest('.form-group').querySelector('.error');
                inputElement.parentElement.appendChild(errorElement);
            },
                rules: {
                    'Name': {
                        required: true
                    },
                    'Email': {
                        required: true
                    },
                    'upload': {
                        required: true
                    }
                }
            }
        }
    }
let formObject: FormValidator = new FormValidator('#form-element', options);
// Add email rule to user element
formObject.addRules('user', { maxLength: 7 });
// Remove number rule from age element
formObject.removeRules('age', ['number']);

Validating a Single Element

The validate method have and optional argument, where you can pass an input element’sname attribute to validate its value against the defined rule.

import {FormValidator, FormValidatorModel} from '@syncfusion/ej2-vue-inputs';

export default {
    data: function() {
        return {
          options : {
        //Initialize the CustomPlacement.
            customPlacement: function(inputElement, errorElement) {
                inputElement = inputElement.closest('.form-group').querySelector('.error');
                inputElement.parentElement.appendChild(errorElement);
            },
                rules: {
                    'Name': {
                        required: true
                    },
                    'Email': {
                        required: true
                    },
                    'upload': {
                        required: true
                    }
                }
            }
        }
    }
let formObject: FormValidator = new FormValidator('#form-element', options);
// Add email rule to user element
formObject.validate('user');